# Notebook overview

In the following, the notebooks' content is briefly described and a useful order for new users is suggested.  

Environment:
* [Set up an experiment/environment with an electirc energy grid](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/Env_Create_DEMO.ipynb)
* [Interacting with the environment - the basic contept](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/Env_Interaction_DEMO.ipynb)

Nodeconstructor:
* [The theoretical principles behind the calculations](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/NodeConstructor_Theory_DEMO.ipynb)
* [Background of automated energy grid configuration](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/NodeConstructor_Application_DEMO.ipynb)

* [Overview of parameters usable for experiment configuration](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/Default_Parameters.ipynb)

Classic controllers:
* [Auxiliaries provided from the classic control side](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/1_Auxiliaries_OU_process.ipynb)

* [Open-loop swing mode - infinite bus](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/RL_Complex_DEMO.ipynb)

* [PQ mode - controllable source and load](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/2_Classical_Controllers_PQ.ipynb)

* [Droop mode - simple grid forming](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/3_Classical_Controllers_Droop.ipynb)

* [VSG mode - enhanced grid forming](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/4_Classical_Controllers_VSG.ipynb)

Reinforcement Learning:
* [Train an RL agent in the ElectricGrid.jl framework](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/NodeConstructor_Theory_DEMO.ipynb)

* [Train an RL agent in a classicly controlled grid](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/RL_Classical_Controllers_Merge_DEMO.ipynb)

* [Train an RL agent controlling the whole grid](https://github.com/upb-lea/ElectricGrid.jl/blob/main/examples/notebooks/RL_Complex_DEMO.ipynb)


Miscellanous:
* [Default parameters - overview](https://github.com/upb-lea/ElectricGrid.jl/blob/develop/examples/notebooks/Default_Parameters.ipynb)